<template>
  <div ref="popup" class="custom-modal">
    <div class="modal-close" @click="close">&#10005;</div>
    <slot> Popup </slot>
  </div>
</template>

<script>
import { mapMutations } from 'vuex'
import { TypesPopup } from '~/constants/store.types'

export default {
  name: 'BasePopup',
  data() {
    return { isVisible: false }
  },
  mounted() {
    document.body.classList.add('modal-open')
    /**
     * @param {KeyboardEvent} e
     */
    window.onkeydown = (e) => {
      if (e.key === 'Escape') {
        this.close()
      }
    }
    /**
     * @param {MouseEvent} e
     */
    window.onclick = (e) => {
      if (e.target.contains(this.$refs.popup)) {
        this.close()
      }
    }
  },
  destroyed() {
    document.body.classList.remove('modal-open')
    window.onkeydown = null
    window.onclick = null
  },
  methods: {
    ...mapMutations({
      close: TypesPopup.mutations.CLOSE_POPUP,
    }),
  },
}
</script>